#! /bin/sh
#
# Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
#pragma ident	"@(#)preremove	1.2	07/04/27 SMI"
#
#
# Preremove script for SUNWdcar.
#
# This script removes the hardware provider section for the dca
# driver from /etc/crypto/kcf.conf
#
DRV=dca

NAMEMAJOR="${BASEDIR}/etc/name_to_major"

#
# Determine if we are on an alternate BASEDIR
#
if [ "${BASEDIR:=/}" = "/" ]
then
        REM_DRV="/usr/sbin/rem_drv"
else
        REM_DRV="/usr/sbin/rem_drv -b ${BASEDIR}"
fi

#
# Remove the driver, but only if this has not already been done.
#
grep -w "${DRV}" ${NAMEMAJOR} > /dev/null 2>&1
if [ $? -eq 0 ]; then
    ${REM_DRV} ${DRV} || exit 1
fi

pkg_start="# Start $PKGINST"
pkg_end="# End $PKGINST"
kcfconf=${BASEDIR}/etc/crypto/kcf.conf
tmpfile=/tmp/$$kcfconf
error=no

#
# If /etc/crypto/kcf.conf doesn't exist, bail immediately
#
if [ ! -f "$kcfconf" ]
then
	echo "$0: ERROR - $kcfconf doesn't exist"
	exit 2
fi

#
# Strip all entries belonging to this package
#
start=0
end=0
egrep -s "$pkg_start" $kcfconf && start=1
egrep -s "$pkg_end" $kcfconf && end=1

if [ $start -ne $end ] ; then
	echo "$0: missing Start or End delimiters for $PKGINST in $kcfconf."
	echo "$0: $kcfconf may be corrupted and was not updated."
	error=yes
	exit 2
fi

if [ $start -eq 1 ]
then
	# To preserve the gid
	cp -p $kcfconf $tmpfile
	sed -e "/$pkg_start/,/$pkg_end/d" $kcfconf > $tmpfile || error=yes
	if [ "$error" = no ]
	then 
		mv $tmpfile $kcfconf || error=yes
	fi
	rm -f $tmpfile
else
	echo "$0: WARNING - no entries to be removed from $kcfconf" 
	exit 0
fi

if [ "$error" = yes ]
then
	echo "$0: ERROR - failed to update $kcfconf."
	exit 2
fi
exit 0
